PipeWire 1.2.6

Loading...
Searching...
No Matches
Files | Data Structures | Typedefs | Macros | Functions
Plugin Handle
SPA » Support

SPA plugin handle and factory interfaces More...

## Files
file | plugin.h
| `spa/support/plugin.h`

## Data Structures
struct | spa_handle
struct | spa_interface_info
| This structure lists the information about available interfaces on handles. More...
struct | spa_support
| Extra supporting infrastructure passed to the init() function of a factory. More...
struct | spa_handle_factory

## Typedefs
typedef int(* | spa_handle_factory_enum_func_t) (const struct spa_handle_factory **factory, uint32_t *index)
| The function signature of the entry point in a plugin.

## Macros
#define | SPA_VERSION_HANDLE 0
| Version of this struct.
#define | spa_handle_get_interface(h, ...)
#define | spa_handle_clear(h)
#define | SPA_SUPPORT_INIT(type, data)
#define | SPA_VERSION_HANDLE_FACTORY 1
| The version of this structure.
#define | spa_handle_factory_get_size(h, ...)
#define | spa_handle_factory_init(h, ...)
#define | spa_handle_factory_enum_interface_info(h, ...)
#define | SPA_HANDLE_FACTORY_ENUM_FUNC_NAME "spa_handle_factory_enum"
#define | SPA_KEY_FACTORY_NAME "factory.name"
| the name of a factory
#define | SPA_KEY_FACTORY_AUTHOR "factory.author"
| a comma separated list of factory authors
#define | SPA_KEY_FACTORY_DESCRIPTION "factory.description"
| description of a factory
#define | SPA_KEY_FACTORY_USAGE "factory.usage"
| usage of a factory
#define | SPA_KEY_LIBRARY_NAME "library.name"
| the name of a library.

## Functions
static void * | spa_support_find (const struct spa_support *support, uint32_t n_support, const char *type)
| Find a support item of the given type.
int | spa_handle_factory_enum (const struct spa_handle_factory **factory, uint32_t *index)
| The entry point in a plugin.

## Detailed Description

SPA plugin handle and factory interfaces

See: SPA Plugins

## Typedef Documentation

## ◆ spa_handle_factory_enum_func_t

typedef int(* spa_handle_factory_enum_func_t) (const struct spa_handle_factory **factory, uint32_t *index)

The function signature of the entry point in a plugin.

Parameters

  factory | a location to hold the factory result
  index | index to keep track of the enumeration

Returns
  1 on success 0 when there are no more factories -EINVAL when factory is NULL

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## Macro Definition Documentation

## ◆ SPA_VERSION_HANDLE

#define SPA_VERSION_HANDLE 0

Version of this struct.

## ◆ spa_handle_get_interface

#define spa_handle_get_interface | ( |  | h,
|  |  | ... )

Value:
(h)->get_interface((h),__VA_ARGS__)

Examples
  bluez-session.c, export-spa.c, local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ spa_handle_clear

#define spa_handle_clear | ( |  | h | ) |

Value:
(h)->clear((h))

## ◆ SPA_SUPPORT_INIT

#define SPA_SUPPORT_INIT | ( |  | type,
|  |  | data )

Value:
((struct spa_support) { (type), (data) })
spa_support
Extra supporting infrastructure passed to the init() function of a factory.
Definition plugin.h:76
spa_support::data
void * data
Definition plugin.h:78
spa_support::type
const char * type
Definition plugin.h:77

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ SPA_VERSION_HANDLE_FACTORY

#define SPA_VERSION_HANDLE_FACTORY 1

The version of this structure.

## ◆ spa_handle_factory_get_size

#define spa_handle_factory_get_size | ( |  | h,
|  |  | ... )

Value:
(h)->get_size((h),__VA_ARGS__)

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ spa_handle_factory_init

#define spa_handle_factory_init | ( |  | h,
|  |  | ... )

Value:
(h)->init((h),__VA_ARGS__)

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ spa_handle_factory_enum_interface_info

#define spa_handle_factory_enum_interface_info | ( |  | h,
|  |  | ... )

Value:
(h)->enum_interface_info((h),__VA_ARGS__)

## ◆ SPA_HANDLE_FACTORY_ENUM_FUNC_NAME

#define SPA_HANDLE_FACTORY_ENUM_FUNC_NAME "spa_handle_factory_enum"

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ SPA_KEY_FACTORY_NAME

#define SPA_KEY_FACTORY_NAME "factory.name"

the name of a factory

Examples
  export-spa-device.c, export-spa.c, and internal.c.

## ◆ SPA_KEY_FACTORY_AUTHOR

#define SPA_KEY_FACTORY_AUTHOR "factory.author"

a comma separated list of factory authors

## ◆ SPA_KEY_FACTORY_DESCRIPTION

#define SPA_KEY_FACTORY_DESCRIPTION "factory.description"

description of a factory

## ◆ SPA_KEY_FACTORY_USAGE

#define SPA_KEY_FACTORY_USAGE "factory.usage"

usage of a factory

## ◆ SPA_KEY_LIBRARY_NAME

#define SPA_KEY_LIBRARY_NAME "library.name"

the name of a library.

This is usually the filename of the plugin without the path or the plugin extension.

Examples
  export-spa-device.c, export-spa.c, and internal.c.

## Function Documentation

## ◆ spa_support_find()

static void * spa_support_find | ( | const struct spa_support * | support,
|  | uint32_t | n_support,
|  | const char * | type )
| inline static

Find a support item of the given type.

## ◆ spa_handle_factory_enum()

int spa_handle_factory_enum | ( | const struct spa_handle_factory ** | factory,
|  | uint32_t * | index )

The entry point in a plugin.

Parameters

  factory | a location to hold the factory result
  index | index to keep track of the enumeration

Returns
  1 on success 0 when no more items are available < 0 errno type error